import json
import os
import os
import pandas as pd
import tqdm
from elasticsearch import Elasticsearch
from elasticsearch.helpers import streaming_bulk

es = Elasticsearch()

# read in all the documents from the local folders
folders = './out'
total_docs = sum([len(files) for r, d, files in os.walk(folders)])


def create_docs():
    for folder in os.listdir(folders):
        path = folders + '/' + folder + '/'
        for file in os.listdir(path):
            with open(path + file, 'r', encoding="utf8") as f:
                data = json.load(f)
                if data['response']:
                    print(data['url'])
                    # a new paragraph is when a string ' ' is encountered
                    lines = [c for c in data['response'].strip().splitlines() if c]
                    paragraphs = []
                    paragraph = ''
                    for line in lines:
                        if line != ' ':
                            paragraph += line
                        else:
                            if paragraph:
                                paragraphs.append(paragraph)
                                paragraph = ''
                    paragraphs.append(paragraph)
                    # convert dataframe to desired json format
                    df = pd.DataFrame(paragraphs, columns=['paragraph'])
                    df['index'] = range(len(paragraphs))
                    paragraphs_dict = df.to_dict(orient='records')

                    data['paragraphs'] = paragraphs_dict
                    data['id'] = file

                    yield data
            break
        break


progress = tqdm.tqdm(unit='docs', total=total_docs)
for ok, action in streaming_bulk(
            client=es, index='documents', actions=create_docs(),
    ):
        progress.update(1)
print('Finished')
