from lxml import etree


class BetsiCadwaladrPipeline(object):

    def process_item(self, item, spider):
        """
        The date for BetsiCadwaladr Spider is mentioned in the referer's pages table in the same row as the url was
        found in. Extract the content for that row and provide it as a better path for the date_pipeline to pick up
        from there
        """

        if spider.name == 'BetsiCadwaladr':
            tree = etree.fromstring(item['referer_html'], etree.HTMLParser())
            date = tree.xpath('//td/p//text()')
            item['helper_date'] = ' '.join(date)

        return item
