from lxml import etree
from urllib.parse import urlparse, unquote


class PowysPipeline(object):

    def process_item(self, item, spider):

        if spider.name == 'Powys':
            tree = etree.fromstring(item['referer_html'], etree.HTMLParser())
            breadcrumb = tree.xpath('.//div[@id="breadcrumb"]//text()')
            item['helper_committee_type'] = breadcrumb[5:11]
            item['helper_item_type'] = unquote(urlparse(item['url']).path).split('/')[-1]
            item['helper_date'] = breadcrumb[-1]

        return item
